using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using NestedHtmlWriter;
using MagSiteLib;

namespace MagSite
{
	/// <summary>
	/// Content ̊Tv̐łB
	/// </summary>
	public class Content : System.Web.UI.Page
	{
		private void writeNextPrev( NhBlock block, FullKeyword keyword, ItemID itemID )
		{
			using( NhTable table = block.CreateTable() )
			{
				table.WriteClassAttr("nextprev");
				using( NhTr tr = table.CreateTr() )
				{
					using( NhThInline thPrev = tr.CreateThInline() )
					{
						thPrev.WriteText("O");
					}
					using( NhThInline thKW = tr.CreateThInline() )
					{
						thKW.WriteText("L[[h̑ÕRec");
					}
					using( NhThInline thNext = tr.CreateThInline() )
					{
						thNext.WriteText("");
					}
				}
				for( int depth=keyword.Keywords.Length; depth>0; depth-- )
				{
					string [] targetNames = new string[depth];
					for( int i=0; i<depth; i++ )
					{
						targetNames[i] = keyword.Keywords[i];
					}
					FullKeyword targetKeyword = new FullKeyword(targetNames);

					ItemID nextKWItemID = ItemListManager.ContentList.GetNextItemIDByKeyword(itemID,targetKeyword);
					ItemID prevKWItemID = ItemListManager.ContentList.GetPrevItemIDByKeyword(itemID,targetKeyword);

					if( !nextKWItemID.IsNoItem() || !prevKWItemID.IsNoItem() )
					{
						using( NhTr tr = table.CreateTr() )
						{
							using( NhTdInline tdPrev = tr.CreateTdInline() )
							{
								tdPrev.WriteClassAttr("nextprev");
								if( !prevKWItemID.IsNoItem() )
								{
									using( NhA itemLink = tdPrev.CreateA() )
									{
										Item item = ItemListManager.ContentList.GetItem(prevKWItemID);
										itemLink.WriteAttribute("href",FileNames.Content + "?id=" + prevKWItemID);
										itemLink.WriteText( "" );
									}
								}
							}
							using( NhTdInline tdKW = tr.CreateTdInline() )
							{
								tdKW.WriteClassAttr("nextprev");
								WriteLib.WriteKeyword(tdKW,targetKeyword,FileNames.Default,string.Empty);
							}
							using( NhTdInline tdNext = tr.CreateTdInline() )
							{
								tdNext.WriteClassAttr("nextprev");
								if( !nextKWItemID.IsNoItem() )
								{
									using( NhA itemLink = tdNext.CreateA() )
									{
										Item item = ItemListManager.ContentList.GetItem(nextKWItemID);
										itemLink.WriteAttribute("href",FileNames.Content + "?id=" + nextKWItemID);
										itemLink.WriteText( "" );
									}
								}
							}

						}
					}
				}
			}
		}
		private void Page_Load(object sender, System.EventArgs e)
		{
			Item item = ItemListManager.ContentList.GetItem( URIQueryParser.ParseID(Request) );

			DateTime now = DateTime.Now;
			ContentAccessRanking.AppendAccessedDate(item.ItemID,now);
			KeywordAccessRanking.AppendAccessedDate(item.Keyword,now);

			SectionDef def = SectionDefManager.GetSectionDef(item.Keyword);
			using( NhQuickDocument doc = new MyOutputDocument( Response.Output, item.Subject, item.Keyword ) )
			{
				int count = ContentAccessRanking.GetTotalAccessRanking(item.Keyword).GetCount(item.ItemID);
				if( item.RenderedBody.Length > 0 )
				{
					WriteLib.WriteContentBody(doc.B,item.ItemID,count,item.Date,item.Keyword,
						item.Subject,item.RenderedBody,EBodyType.XhtmlByText,item.AttachedFiles,
						item.PeruAsin,false);
				}
				else
				{
					WriteLib.WriteContentBody(doc.B,item.ItemID,count,item.Date,item.Keyword,
						item.Subject,item.Body,item.BodyType,item.AttachedFiles,
						item.PeruAsin,false);
				}

				writeNextPrev(doc.B,item.Keyword,item.ItemID);
				TrackBackRecord [] records = TrackBackRecordManager.GetRecords( item.ItemID );
				if( records.Length > 0 )
				{
					using( NhTable table = doc.B.CreateTable() )
					{
						using( NhTr tr = table.CreateTr() )
						{
							using( NhThBlock th = tr.CreateThBlock() )
							{
								th.WriteClassAttr("tblist");
								using( NhHx h2 = th.CreateHx(2) )
								{
									h2.WriteClassAttr("trackBackTitle");
									h2.WriteText("gbNobNꗗ");
								}
							}
						}
						for( int i=0; i<records.Length; i++ )
						{
							TrackBackRecord record = records[records.Length-i-1];
							using( NhTr tr = table.CreateTr() )
							{
								using( NhTdBlock td = tr.CreateTdBlock() )
								{
									td.WriteClassAttr("tblist");
									WriteLib.WriteTrackBackInfoForUser( td,
										record.RecievedDateTime,
										record.Title,
										record.Excerpt,
										record.SiteName,
										record.Url);
								}
							}
						}
					}
				}
				using( NhTable table = doc.B.CreateTable() )
				{
					table.WriteClassAttr("tburl");
					using( NhTr tr = table.CreateTr() )
					{
						using( NhThInline th = tr.CreateThInline() )
						{
							th.WriteClassAttr("tburl");
							th.WriteText("̃RecփgbNobN邽߂URL");
						}
					}
					using( NhTr tr = table.CreateTr() )
					{
						using( NhTdInline td = tr.CreateTdInline() )
						{
							td.WriteClassAttr("tburl");
							td.WriteText( WriteLib.CreateMyUri(Request.Url,"tb.aspx/" + item.ItemID,"") );
						}
					}
				}
#if false
				using( NhP p = doc.B.CreateP() )
				{
					using( NhSpan span = p.CreateSpan() )
					{
						span.WriteText("̃Recւ̃gbNobNURL: ");
					}
					using( NhSpan span = p.CreateSpan() )
					{
						span.WriteText( WriteLib.CreateMyUri(Request.Url,"tb.aspx/" + item.ItemID,"") );
					}
				}
#endif
				WriteLib.WriteHorizontalLine(doc.B);
				WriteLib.WriteNormalFooter(doc.B,item.Keyword);
			}
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
