using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using MagSiteLib;

namespace MagSite
{
	/// <summary>
	/// rss ̊Tv̐łB
	/// </summary>
	public class rss : System.Web.UI.Page
	{
		private const string rss10ns = "http://purl.org/rss/1.0/";
		private const string rdfns = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
		private const string dcns = "http://purl.org/dc/elements/1.1/";

		private string getRSSDate( DateTime datetime )
		{
			DateTime utcTime = datetime.ToUniversalTime();
			//<dc:date>2003-06-06T13:21:50Z</dc:date>
			return utcTime.ToString("yyyy-MM-dd'T'HH:mm:ss'Z'");
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			FullKeyword keyword = URIQueryParser.ParseKeyword(Request);
			SectionDef def = SectionDefManager.GetSectionDef(keyword);

			// Todo: ȉ̋Lqdefault.aspxƓȂ̂œׂ
			string title = def.Title;
			string subTitle = "";
			string pageTitle = title;
			if( !keyword.IsRootKeyword() )
			{
				subTitle = keyword.Keywords[keyword.Keywords.Length-1];
				pageTitle = title + " " + "y" + subTitle + "z";
			}

			Response.ContentType = "application/xml";
			Response.ContentEncoding = System.Text.Encoding.UTF8;

			XmlTextWriter writer = new XmlTextWriter(Response.OutputStream,System.Text.Encoding.UTF8);
			try
			{
				writer.WriteStartDocument();
				writer.Formatting = Formatting.Indented;

#if false
				writer.WriteProcessingInstruction("xml-stylesheet","href=\"rss.xsl\" type=\"text/xsl\" media=\"screen\"");
#endif

				writer.WriteStartElement("rdf","RDF",rdfns);
				writer.WriteAttributeString("xmlns",null,rss10ns);
				writer.WriteAttributeString("xmlns", "dc", null, dcns);
				writer.WriteAttributeString("xml", "lang", null, "ja");

				writer.WriteStartElement("channel",rss10ns);
				writer.WriteAttributeString("about",rdfns,Request.Url.AbsoluteUri);
				writer.WriteElementString("title",rss10ns,pageTitle + " Update Information");

				string uri;
				if( keyword.IsRootKeyword() )
				{
					uri = WriteLib.CreateMyUri(Request.Url,FileNames.Default,"");
				}
				else
				{
					uri = WriteLib.CreateMyUri(Request.Url,FileNames.Default,WriteLib.BuildKeywordParameter(keyword));
				}
				writer.WriteElementString("link",rss10ns,uri);

				writer.WriteElementString("title",dcns,pageTitle);
				writer.WriteElementString("creator",dcns,def.AdminstratorName);

				ItemID latestItemID = ItemListManager.ContentList.GetLatestItemID( keyword );
				if( !latestItemID.IsNoItem() )
				{
					DateTime lastUpdatedDateTime = latestItemID.GetDateTime();
					writer.WriteElementString("date",dcns,getRSSDate(lastUpdatedDateTime));
				}
				writer.WriteElementString("language",dcns,"ja");
#if false
				writer.WriteStartElement("rights",dcns);
				writer.WriteAttributeString("rdf","resource",rdfns,"http://xxxxxxx/disclaimer");
				writer.WriteEndElement();
#endif
				writer.WriteElementString("description",rss10ns,"RSSf[^́AwL[[h̍ŋ߂̍XV15RecłB");
				writer.WriteStartElement("items",rss10ns);
				writer.WriteStartElement("Seq",rdfns);

				ItemID [] items = ItemListManager.ContentList.GetItemIDsIncludingSubKeywords(keyword);
				Array.Sort(items);
				int count = 0;
				int p = items.Length-1;
				while( true )
				{
					if( count >= 15 ) break;
					if( p < 0 ) break;
					string contentUri = WriteLib.BuildContentAbsoluteUrl(Request.Url,items[p]);
					writer.WriteStartElement("li",rdfns);
					writer.WriteAttributeString("rdf","resource",rdfns,contentUri);
					writer.WriteEndElement();
					count ++;
					p--;
				}
				writer.WriteEndElement();
				writer.WriteEndElement();
				writer.WriteEndElement();

				int count2 = 0;
				int p2 = items.Length-1;
				while( true )
				{
					if( count2 >= 15 ) break;
					if( p2 < 0 ) break;
					string contentUri2 = WriteLib.BuildContentAbsoluteUrl(Request.Url,items[p2]);
					writer.WriteStartElement("item",rss10ns);
					writer.WriteAttributeString("rdf","about",rdfns,contentUri2);

					Item item = ItemListManager.ContentList.GetItem(items[p2]);
					string lastKeyword = item.Keyword.Keywords[item.Keyword.Keywords.Length-1];
					string digest = "L[[h: " + WriteLib.KeywordToHumanReadableString(item.Keyword)
						+ "\r\n" + "{擪:\r\n"
						+ item.GetDigestText();
					writer.WriteElementString("title",rss10ns,item.Subject);
					writer.WriteElementString("link",rss10ns,contentUri2);
					writer.WriteElementString("description",rss10ns,digest);
					writer.WriteElementString("date",dcns,getRSSDate(items[p2].GetDateTime()));
					writer.WriteElementString("subject",dcns,WriteLib.KeywordToShortHumanReadableString(item.Keyword));

					writer.WriteEndElement();
					count2 ++;
					p2--;
				}

				writer.WriteEndElement();
				writer.WriteEndDocument();
			}
			finally
			{
				writer.Flush();
			}
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
