using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.Net;
using MagSiteLib;

namespace MagSite
{
	public class TrackBackPage : System.Web.UI.Page
	{
		private void sendAdministrator( ItemID itemID, TrackBackRecord record )
		{
			Item item = ItemListManager.ContentList.GetItem( itemID );
			SectionDef def = SectionDefManager.GetSectionDef(item.Keyword);

			System.Text.StringBuilder sb = new System.Text.StringBuilder();
			sb.Append( def.Title );
			sb.Append( "̃Recւ̃gbNobNM܂B\r\n" );
			sb.Append( "\r\n" );
			sb.Append( "MΏۂƂȂRec\r\n" );
			sb.Append( "ID: " );
			sb.Append( itemID.ToString() );
			sb.Append( "\r\n" );
			sb.Append( "Subject: " );
			sb.Append( item.Subject );
			sb.Append( "\r\n" );
			sb.Append( "Keyword: " );
			sb.Append( WriteLib.KeywordToHumanReadableString(item.Keyword) );
			sb.Append( "\r\n" );
			sb.Append( "\r\n" );
			sb.Append( "MꂽgbNobNe\r\n" );
			sb.Append( "^Cg: " );
			sb.Append( record.Title );
			sb.Append( "\r\n" );
			sb.Append( "TCg: " );
			sb.Append( record.SiteName );
			sb.Append( "\r\n" );
			sb.Append( "URL: " );
			sb.Append( record.Url );
			sb.Append( "\r\n" );
			sb.Append( "IPAhX: " );
			sb.Append( record.IpAddress.ToString() );
			sb.Append( "\r\n" );
			sb.Append( "Tv: " );
			int p = 0;
			while( true )
			{
				if( p >= record.Excerpt.Length ) break;
				int left = Math.Min(36,record.Excerpt.Length-p);
				sb.Append( record.Excerpt.Substring(p,left) );
				sb.Append( "\r\n" );
				p += left;
			}

			sb.Append( "\r\n" );
			sb.Append( MagSiteLib.Version.PoweredByFullName );
			sb.Append( "\r\n" );

			MailSender.Send( def.AdminstratorMailAddress, def.AdminstratorMailAddress,
				def.Title + " gbNobNM|[g",
				sb.ToString(),
				def.SmtpServerHostName, new string[0] );
		}

		private void writeTrackBackResponse( bool errorState, string message )
		{
			Response.ContentType = "application/xml";
			Response.ContentEncoding = System.Text.Encoding.UTF8;

			XmlTextWriter writer = new XmlTextWriter(Response.OutputStream,System.Text.Encoding.UTF8);
			try
			{
				writer.WriteStartDocument();
				writer.Formatting = Formatting.Indented;
				writer.WriteStartElement("response");
				writer.WriteElementString("error",errorState ? "1" : "0" );
				if( errorState )
				{
					writer.WriteElementString("message",message);
				}
				writer.WriteEndElement();
				writer.WriteEndDocument();
			}
			finally
			{
				writer.Flush();
			}
		}

		private string simpleCheck( string name )
		{
			if( Request[name] != null && Request[name].Trim().Length > 0 )
			{
				return Request[name].Trim();
			}
			writeTrackBackResponse(true,"p[^ [" + name + "]w肳Ă܂BTrackBack ping͎󂯕t܂łB");
			return string.Empty;
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			string id = Request.PathInfo;
			if( id.StartsWith("/") )
			{
				id = id.Substring(1);
			}
			ItemID itemID = new ItemID(id);

			if( Request.HttpMethod.ToUpper() != "POST" )
			{
				writeTrackBackResponse(true,"["+ Request.HttpMethod + "]NGXgM܂BPOSTNGXĝ݂󂯕t܂BTrackBack ping͎󂯕t܂łB");
				return;
			}

			if( Request["charset"] != null && Request["charset"].Trim().Length > 0 )
			{
				string encodingName = Request["charset"].Trim();
				if( encodingName.ToUpper() != "UTF-8" )
				{
					writeTrackBackResponse(true,"charset=["+ encodingName + "]̃NGXgM܂BUTF-8݂̂󂯕t܂BTrackBack ping͎󂯕t܂łB");
					return;
				}
			}

			string title = simpleCheck("title");
			if( title == string.Empty ) return;

			string excerpt = simpleCheck("excerpt");
			if( excerpt == string.Empty ) return;

			string url = simpleCheck("url");
			if( url == string.Empty ) return;

			string siteName = simpleCheck("blog_name");
			if( siteName == string.Empty ) return;

			TrackBackRecord record = new TrackBackRecord(itemID,title,excerpt,url,
				siteName,IPAddress.Parse(Request.UserHostAddress),DateTime.Now);

			lock( ItemListManager.ContentList )
			{
				if( !ItemListManager.ContentList.IsExist(itemID) )
				{
					writeTrackBackResponse(true,"ID: [" + id + "]݂͑܂BTrackBack ping͎󂯕t܂łB");
					return;
				}
				TrackBackRecordManager.AddRecord( itemID, record );
			}

			writeTrackBackResponse(false,"");

			sendAdministrator( itemID, record );
		}

		#region Web tH[ fUCiŐꂽR[h 
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: ̌ĂяóAASP.NET Web tH[ fUCiŕKvłB
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
